Sebastian Raschka, 2015

Python Machine Learning - Code Examples


## Chapter 3 - A Tour of Machine Learning Classifiers Using Scikit-learn

- Choosing a classification algorithm
- First steps with scikit-learn
    - Training a perceptron via scikit-learn
- Modeling class probabilities via logistic regression
    - Logistic regression intuition and conditional probabilities
    - Learning the weights of the logistic cost function
    - Training a logistic regression model with scikit-learn
    - Tackling overfitting via regularization
- Maximum margin classification with support vector machines
    - Maximum margin intuition
    - Dealing with the nonlinearly separable case using slack variables
    - Alternative implementations in scikit-learn
- Solving nonlinear problems using a kernel SVM
    - Using the kernel trick to find separating hyperplanes in higher dimensional space
- Decision tree learning
    - Maximizing information gain – getting the most bang for the buck
    - Building a decision tree
    - Combining weak to strong learners via random forests
- K-nearest neighbors – a lazy learning algorithm
- Summary