Sebastian Raschka, 2015

Python Machine Learning - Code Examples

##  Chapter 6 - Learning Best Practices for Model Evaluation and Hyperparameter Tuning

- Streamlining workflows with pipelines
  - Loading the Breast Cancer Wisconsin dataset
  - Combining transformers and estimators in a pipeline
- Using k-fold cross-validation to assess model performance
  - The holdout method
  - K-fold cross-validation
- Debugging algorithms with learning and validation curves
  - Diagnosing bias and variance problems with learning curves
  - Addressing overfitting and underfitting with validation curves
- Fine-tuning machine learning models via grid search
  - Tuning hyperparameters via grid search
  - Algorithm selection with nested cross-validation
- Looking at different performance evaluation metrics
  - Reading a confusion matrix
  - Optimizing the precision and recall of a classification model
  - Plotting a receiver operating characteristic
  - The scoring metrics for multiclass classification
- Summary

