Sebastian Raschka, 2015

Python Machine Learning - Code Examples

## Chapter 10 - Predicting Continuous Target Variables with Regression Analysis

- Introducing a simple linear regression model
- Exploring the Housing Dataset
  - Visualizing the important characteristics of a dataset
- Implementing an ordinary least squares linear regression model
  - Solving regression for regression parameters with gradient descent
  - Estimating the coefficient of a regression model via scikit-learn
- Fitting a robust regression model using RANSAC
- Evaluating the performance of linear regression models
- Using regularized methods for regression
- Turning a linear regression model into a curve – polynomial regression
  - Modeling nonlinear relationships in the Housing Dataset
  - Dealing with nonlinear relationships using random forests
    - Decision tree regression
    - Random forest regression
- Summary