The *Known Errors* Leaderboard
========================


### Note (2016-04-15)

 ~~I am happy to say that layout team recently agreed to fix all the errors listed in the current errata! The fixes have already been applied, and I got a glance at the current version last -- it looks good :). So, based on what I've heard, the revised version will go online on April 19th, 2016 across the various platforms. If you got the book via Packt directly, you just need to log back in to re-download the .pdf, .epub, and/or .mobi files. Also, I was told that the same applies to the Kindle and iBooks versions and so forth. There may be a few delays depending on how fast the servers propagate the changes, but I will check back next week and post another update as soon as I see that the revision's gone life! Also, I want to say that I am really, really happy about all your feedback, and I really appreciate the nice words you are sending me about the book despite the little typos here and there! Thank you!~~

### Note (2016-04-23)

**I just checked the e-book out via my Packt account; I am happy to announce that the revision has gone live! Based on my interpretation of the publisher's feedback, the revision should be available via the other platforms as well. Based on reader feedback, the revised version is also available via O'Reilly, and it's definitely available via Amazon (I've had the chance to look at a recent paperback). Please scroll down to the "Current Errata" section below for more information on the current state of the book.**


---

I tried my best to cut all the little typos, errors, and formatting bugs that slipped through the copy editing stage. Even so, I think it is just human to have a little typo here and there in a first edition. I know that this can be annoying as a reader, and I was thinking to associate it with something positive. Let's have a little leaderboard (inspired by Donald Knuth's "[Known Errors in My Books](http://www-cs-faculty.stanford.edu/~uno/books.html)").

**Every error that is not listed in the *Errata* yet will be rewarded with $1.**
The only catch here is that you won't receive any single cent. Instead, I am going to donate the amount to [UNICEF USA](http://www.unicefusa.org), the US branch of the United Nations agency for raising funds to provide emergency food and healthcare for children in developing countries.

I would be happy if you just write me a short [mail](mailto:mail@sebastianraschka.com) including the error and page number, and please let me know if you want to be listed on the public leaderboard.



## Donations

- Current amount for the next donation: $19.00
- Amount donated to charity:
  - [$39.00 2016-04-07](./2016-04-07-unicef.pdf)
  - [$76.00 2016-03-03](./2016-03-03-unicef.pdf)

## Leaderboard

1. Jeremy N. ($40.00)
1. Ryan S. ($24.00)
2. Claude C. ($11.00)
2. Christopher Galpin ($8.00)
18. David C. ($6.00)
2. Edgar C. ($5.00)
27. Jozef Genzor ($5.00)
3. S.R. ($4.00)
3. Will P. ($4.00)
3. Ignacio A. ($4.00)
4. Joseph Gordon ($3.00)
6. Ilmo S. ($3.00)
7. Hyun L. ($3.00)
5. Ailin M. ($2.00)
8. T.S. Jayram ($2.00)
9. Andrei R. ($2.00)
10. Panos N. ($2.00)
19. F. Liu ($2.00)
20. Stefan P. ($2.00)
11. Elias R. ($1.00)
12. Haitham H. Saleh ($1.00)
13. Muqueet M. ($1.00)
14. Renato R. ($1.00)
15. Michael L. ($1.00)
16. Olaf R. ($1.00)
17. Neeraj K. ($1.00)
18. Dan I. ($1.00)
19. Evan Colvin ($1.00)
21. Dominik S. ($1.00)
22. Andrei R. ($1.00)
23. Richard L. ($1.00)
24. Justin H. ($1.00)
25. Neeraj K. ($1.00)
26. Attila B. ($1.00)
27. Simon C. ($1.00)
28. Andrew R. ($1.00)


...

# Errata

**I am really sorry about you seeing many typos up in the equations so far. Unfortunately, the layout team needed to retype the equations for compatibility reasons. There were a lot of typos introduced during this process, and I tried my very best to eliminate all of these by comparing the pre-finals against my draft. Cross-comparing 450 pages was a tedious task, and it appears that several typos slipped through, so if you see something that does not make quite sense to you, please let me know.**


**Note**

Due to the large file sizes of the PDFs, I moved the errata documents to an external source to keep this GitHub repository reasonably slim. For similar reasons, I decided to split the errata into 2 parts, a "technical" errata and a "language" errata.

### Current Errata:


**How can I tell if I have the initial or updated version of the book?**

This time, the easiest way may be to go to page 6 in chapter 1. Finally, the labeling in the *reinforcement learning* figure should be correct!

![](./images/errata/errata_2016-04-22.jpg)


#### [Technical Errata PDF v.3](http://sebastianraschka.com/pdf/books/pymle/errata_3rd_technical.pdf)

#### [Language Errata PDF v.3](http://sebastianraschka.com/pdf/books/pymle/errata_3rd_language.pdf)


### Old Errata: Oct 25, 2015 - Apr 22, 2016




#### [Technical Errata PDF v.2](http://sebastianraschka.com/pdf/books/pymle/errata_2nd_technical.pdf)

#### [Language Errata PDF v.2](http://sebastianraschka.com/pdf/books/pymle/errata_2nd_language.pdf)

(Left-click to view it in the browser; right-click for select a direct download option from the context menu.)

**E-book Update (2015-10-20):**    

Good news! I just heard back from the publisher; all the typos and errors which are listed below will be fixed by next week. If you bought the book via Packt, you'd just need to re-download the book. I hope that the updates will also be reflected in the Amazon Kindle version. If not, please contact me, and I'll be happy to make an arrangement with the publisher so that you'll get the updated e-book.
I am really sorry about the inconvenience, and I really there weren't any errors in the first place. As Alexander Pope once said:

> *to err is human; to forgive, divine*

 I really hope you can overlook these little mishaps, but please do look over the errata, since I really don't want these typos to become misleading!


**How can I tell if I have the initial or updated version of the book?**

The easiest way may be to go to page viii, the second page of the **Preface**. If you see *Classifiers* spelled as *Classifirs*, that's definitely an old version then!

![](./images/errata/errata_2015-10-20.png)


---

### Old Errata: Sep 23 - Oct 25, 2015


I converted the errata into a PDF document where I highlighted the errors and inserted the corrections as they appear in the book as many readers suggested. Please find the PDF version of the errata below.  
Thanks so much for your feedback so far, I truly appreciate it and will do my best to get this fixed as soon as possible!

**Note**

Due to the large file sizes of the PDFs, I moved the errata documents to an external source to keep this GitHub repository reasonably slim.

#### [Technical Errata PDF v.1](http://sebastianraschka.com/pdf/books/pymle/errata_1st_technical.pdf)

#### [Language Errata PDF v.1](http://sebastianraschka.com/pdf/books/pymle/errata_1st_language.pdf)

(Left-click to view it in the browser; right-click for select a direct download option from the context menu.)
